<?php
/*
GUN's Life Time
--------------------------

 General Public License
 http://www.gnu.org/licenses/gpl.html

 author  : 건이아빠 <yangkun7@gmail.com>
 blog    : 건이네 <http://www.yangkun.pe.kr>
 translation ：Baro http://www.ddokbaro.com  ddokbaro@gmail.com
 version : 20070327.1

			2007-03-27 : 시분초 없애기 옵션추가. 선택시 일 까지만 출력
*/

define("GUN_LifeTime_dateFormat", "([0-9]{4})\-([0-9]{1,2})\-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", true);

function GUN_displayLifeTime()
{
	global $database, $owner, $configVal, $hostURL, $blogURL, $pluginURL, $service, $blog;
	requireComponent('Tattertools.Function.misc');
	$cfg = misc::fetchConfigVal($configVal);

	$timeDivisors = array(1 => 1, 60, 60*60, 60*60*24, 60*60*24*30, 60*60*24*30*12);
	$timeNames = array(1=>' 秒 ',' 分 ',' 时 ',' 日 ',' 月 ',' 年 ');

	$timeString = "";
	if (ereg(GUN_LifeTime_dateFormat, $cfg['startDate'], $matches))
	{
		$startTime = mktime(intval($matches[4]), intval($matches[5]), intval($matches[6]), intval($matches[2]), intval($matches[3]), intval($matches[1]));
		$elapsedTime = time() - $startTime;
		for ($funcIndex = $cfg['displayType']; $funcIndex >= 1; $funcIndex--)
		{
			if ($cfg['delTail'] && $funcIndex == 3) break;
			$timeString .= GUN_LifeTimeConvert($elapsedTime, $timeDivisors[$funcIndex], $timeNames[$funcIndex]);
		}
	}

	return "<div class='GUNLifeTime'>{$cfg['displayPrefix']}<span class='GUNLifeTime'>{$timeString}</span>{$cfg['displaySuffix']}</div>";
}

function GUN_LifeTimeDataSet($post)
{
	requireComponent('Tattertools.Function.misc');
	$cfg = misc::fetchConfigVal($post);

	if (!$cfg['startDate'] || trim($cfg['startDate']) == '') return "入开始日期";
	if (!ereg(GUN_LifeTime_dateFormat, $cfg['startDate'])) return "输入的开始日期不符合各式";

	return true;
}

function GUN_LifeTimeConvert(&$time, $duration, $name)
{
	$re = "";
	$t = intval($time / $duration);
	if ($t > 0)
	{
		$time -= $t * $duration;
		$re = number_format($t) . $name;
	}
	return $re;
}
?>